/* Events: Sample, Zero Crossings, Relations, Discrete Changes */
#include "WaterTank_Control_model.h"
#if defined(__cplusplus)
extern "C" {
#endif

/* Initializes the raw time events of the simulation using the now
   calcualted parameters. */
void WaterTank_Control_function_initSample(DATA *data, threadData_t *threadData)
{
  long i=0;
}

const char *WaterTank_Control_zeroCrossingDescription(int i, int **out_EquationIndexes)
{
  static const char *res[] = {"level <= minlevel",
  "level >= maxlevel"};
  static const int occurEqs0[] = {1,7};
  static const int occurEqs1[] = {1,6};
  static const int *occurEqs[] = {occurEqs0,occurEqs1};
  *out_EquationIndexes = (int*) occurEqs[i];
  return res[i];
}

/* forwarded equations */

int WaterTank_Control_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;

  
  TRACE_POP
  return 0;
}

int WaterTank_Control_function_ZeroCrossings(DATA *data, threadData_t *threadData, double *gout)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp0;
  modelica_real tmp1;
  modelica_real tmp2;
  modelica_boolean tmp3;
  modelica_real tmp4;
  modelica_real tmp5;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_tick(SIM_TIMER_ZC);
#endif
  data->simulationInfo->callStatistics.functionZeroCrossings++;

  tmp1 = 1.0;
  tmp2 = fabs((data->simulationInfo->realParameter[1] /* minlevel PARAM */));
  tmp0 = LessEqZC((data->localData[0]->realVars[0] /* level variable */), (data->simulationInfo->realParameter[1] /* minlevel PARAM */), tmp1, tmp2, data->simulationInfo->storedRelations[0]);
  gout[0] = (tmp0) ? 1 : -1;

  tmp4 = 1.0;
  tmp5 = fabs((data->simulationInfo->realParameter[0] /* maxlevel PARAM */));
  tmp3 = GreaterEqZC((data->localData[0]->realVars[0] /* level variable */), (data->simulationInfo->realParameter[0] /* maxlevel PARAM */), tmp4, tmp5, data->simulationInfo->storedRelations[1]);
  gout[1] = (tmp3) ? 1 : -1;

#if !defined(OMC_MINIMAL_RUNTIME)
  if (measure_time_flag) rt_accumulate(SIM_TIMER_ZC);
#endif

  TRACE_POP
  return 0;
}

const char *WaterTank_Control_relationDescription(int i)
{
  const char *res[] = {"level <= minlevel",
  "level >= maxlevel"};
  return res[i];
}

int WaterTank_Control_function_updateRelations(DATA *data, threadData_t *threadData, int evalforZeroCross)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;

  modelica_boolean tmp6;
  modelica_real tmp7;
  modelica_real tmp8;
  modelica_boolean tmp9;
  modelica_real tmp10;
  modelica_real tmp11;
  
  if(evalforZeroCross) {
    tmp7 = 1.0;
    tmp8 = fabs((data->simulationInfo->realParameter[1] /* minlevel PARAM */));
    tmp6 = LessEqZC((data->localData[0]->realVars[0] /* level variable */), (data->simulationInfo->realParameter[1] /* minlevel PARAM */), tmp7, tmp8, data->simulationInfo->storedRelations[0]);
    data->simulationInfo->relations[0] = tmp6;

    tmp10 = 1.0;
    tmp11 = fabs((data->simulationInfo->realParameter[0] /* maxlevel PARAM */));
    tmp9 = GreaterEqZC((data->localData[0]->realVars[0] /* level variable */), (data->simulationInfo->realParameter[0] /* maxlevel PARAM */), tmp10, tmp11, data->simulationInfo->storedRelations[1]);
    data->simulationInfo->relations[1] = tmp9;
  } else {
    data->simulationInfo->relations[0] = ((data->localData[0]->realVars[0] /* level variable */) <= (data->simulationInfo->realParameter[1] /* minlevel PARAM */));

    data->simulationInfo->relations[1] = ((data->localData[0]->realVars[0] /* level variable */) >= (data->simulationInfo->realParameter[0] /* maxlevel PARAM */));
  }
  
  TRACE_POP
  return 0;
}

#if defined(__cplusplus)
}
#endif

