#include "simulation_data.h"

OMC_DISABLE_OPT

void WaterTank_Control_read_simulation_info(SIMULATION_INFO* simulationInfo)
{
  simulationInfo->startTime = 0.0;
  simulationInfo->stopTime = 1.0;
  simulationInfo->stepSize = 0.002;
  simulationInfo->tolerance = 1e-6;
  simulationInfo->solverMethod = "dassl";
  simulationInfo->outputFormat = "mat";
  simulationInfo->variableFilter = ".*";
  simulationInfo->OPENMODELICAHOME = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/build/bin/..";
}

void WaterTank_Control_read_input_fmu(MODEL_DATA* modelData)
{
  modelData->realVarsData[0].info.id = 1000;
  modelData->realVarsData[0].info.name = "level";
  modelData->realVarsData[0].info.comment = "";
  modelData->realVarsData[0].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->realVarsData[0].info.info.lineStart = 67;
  modelData->realVarsData[0].info.info.colStart = 5;
  modelData->realVarsData[0].info.info.lineEnd = 67;
  modelData->realVarsData[0].info.info.colEnd = 256;
  modelData->realVarsData[0].info.info.readonly = 0;
  modelData->realVarsData[0].attribute.unit = "";
  modelData->realVarsData[0].attribute.displayUnit = "";
  modelData->realVarsData[0].attribute.min = -DBL_MAX;
  modelData->realVarsData[0].attribute.max = DBL_MAX;
  modelData->realVarsData[0].attribute.fixed = 1;
  modelData->realVarsData[0].attribute.useNominal = 0;
  modelData->realVarsData[0].attribute.nominal = 1.0;
  modelData->realVarsData[0].attribute.start = 0.0;
  modelData->realVarsData[1].info.id = 1001;
  modelData->realVarsData[1].info.name = "valve";
  modelData->realVarsData[1].info.comment = "";
  modelData->realVarsData[1].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->realVarsData[1].info.info.lineStart = 68;
  modelData->realVarsData[1].info.info.colStart = 5;
  modelData->realVarsData[1].info.info.lineEnd = 68;
  modelData->realVarsData[1].info.info.colEnd = 266;
  modelData->realVarsData[1].info.info.readonly = 0;
  modelData->realVarsData[1].attribute.unit = "";
  modelData->realVarsData[1].attribute.displayUnit = "";
  modelData->realVarsData[1].attribute.min = -DBL_MAX;
  modelData->realVarsData[1].attribute.max = DBL_MAX;
  modelData->realVarsData[1].attribute.fixed = 0;
  modelData->realVarsData[1].attribute.useNominal = 0;
  modelData->realVarsData[1].attribute.nominal = 1.0;
  modelData->realVarsData[1].attribute.start = 0.0;
  modelData->realVarsData[2].info.id = 1002;
  modelData->realVarsData[2].info.name = "$outputAlias_valve";
  modelData->realVarsData[2].info.comment = "";
  modelData->realVarsData[2].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->realVarsData[2].info.info.lineStart = 68;
  modelData->realVarsData[2].info.info.colStart = 5;
  modelData->realVarsData[2].info.info.lineEnd = 68;
  modelData->realVarsData[2].info.info.colEnd = 266;
  modelData->realVarsData[2].info.info.readonly = 0;
  modelData->realVarsData[2].attribute.unit = "";
  modelData->realVarsData[2].attribute.displayUnit = "";
  modelData->realVarsData[2].attribute.min = -DBL_MAX;
  modelData->realVarsData[2].attribute.max = DBL_MAX;
  modelData->realVarsData[2].attribute.fixed = 1;
  modelData->realVarsData[2].attribute.useNominal = 0;
  modelData->realVarsData[2].attribute.nominal = 1.0;
  modelData->realVarsData[2].attribute.start = 0.0;
  modelData->realParameterData[0].info.id = 1003;
  modelData->realParameterData[0].info.name = "maxlevel";
  modelData->realParameterData[0].info.comment = "";
  modelData->realParameterData[0].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->realParameterData[0].info.info.lineStart = 66;
  modelData->realParameterData[0].info.info.colStart = 5;
  modelData->realParameterData[0].info.info.lineEnd = 66;
  modelData->realParameterData[0].info.info.colEnd = 32;
  modelData->realParameterData[0].info.info.readonly = 0;
  modelData->realParameterData[0].attribute.unit = "";
  modelData->realParameterData[0].attribute.displayUnit = "";
  modelData->realParameterData[0].attribute.min = -DBL_MAX;
  modelData->realParameterData[0].attribute.max = DBL_MAX;
  modelData->realParameterData[0].attribute.fixed = 1;
  modelData->realParameterData[0].attribute.useNominal = 0;
  modelData->realParameterData[0].attribute.nominal = 1.0;
  modelData->realParameterData[0].attribute.start = 3.0;
  modelData->realParameterData[1].info.id = 1004;
  modelData->realParameterData[1].info.name = "minlevel";
  modelData->realParameterData[1].info.comment = "";
  modelData->realParameterData[1].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->realParameterData[1].info.info.lineStart = 65;
  modelData->realParameterData[1].info.info.colStart = 5;
  modelData->realParameterData[1].info.info.lineEnd = 65;
  modelData->realParameterData[1].info.info.colEnd = 32;
  modelData->realParameterData[1].info.info.readonly = 0;
  modelData->realParameterData[1].attribute.unit = "";
  modelData->realParameterData[1].attribute.displayUnit = "";
  modelData->realParameterData[1].attribute.min = -DBL_MAX;
  modelData->realParameterData[1].attribute.max = DBL_MAX;
  modelData->realParameterData[1].attribute.fixed = 1;
  modelData->realParameterData[1].attribute.useNominal = 0;
  modelData->realParameterData[1].attribute.nominal = 1.0;
  modelData->realParameterData[1].attribute.start = 1.0;
  modelData->booleanVarsData[0].info.id = 1005;
  modelData->booleanVarsData[0].info.name = "$whenCondition1";
  modelData->booleanVarsData[0].info.comment = "level <= minlevel";
  modelData->booleanVarsData[0].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->booleanVarsData[0].info.info.lineStart = 71;
  modelData->booleanVarsData[0].info.info.colStart = 7;
  modelData->booleanVarsData[0].info.info.lineEnd = 71;
  modelData->booleanVarsData[0].info.info.colEnd = 18;
  modelData->booleanVarsData[0].info.info.readonly = 0;
  modelData->booleanVarsData[0].attribute.fixed = 1;
  modelData->booleanVarsData[0].attribute.start = 0;
  modelData->booleanVarsData[1].info.id = 1006;
  modelData->booleanVarsData[1].info.name = "$whenCondition2";
  modelData->booleanVarsData[1].info.comment = "level >= maxlevel";
  modelData->booleanVarsData[1].info.info.filename = "/var/lib/jenkins2/ws/OpenModelica_PR-12608/testsuite/special/FmuExportCrossCompile/WaterTank.mo";
  modelData->booleanVarsData[1].info.info.lineStart = 71;
  modelData->booleanVarsData[1].info.info.colStart = 7;
  modelData->booleanVarsData[1].info.info.lineEnd = 71;
  modelData->booleanVarsData[1].info.info.colEnd = 18;
  modelData->booleanVarsData[1].info.info.readonly = 0;
  modelData->booleanVarsData[1].attribute.fixed = 1;
  modelData->booleanVarsData[1].attribute.start = 0;
}