/* Simulation code for WaterTank.Control generated by the OpenModelica Compiler OMCompiler v1.24.0-dev.157+gb8f9b15513. */
#if !defined(WaterTank_Control__MODEL_H)
#define WaterTank_Control__MODEL_H

#include "openmodelica.h"
#include "openmodelica_func.h"
#include "simulation_data.h"
#include "simulation/simulation_info_json.h"
#include "simulation/simulation_runtime.h"
#include "util/omc_error.h"
#include "util/parallel_helper.h"
#include "simulation/jacobian_util.h"
#include "simulation/simulation_omc_assert.h"
#include "simulation/solver/model_help.h"
#include "simulation/solver/delay.h"
#include "simulation/solver/linearSystem.h"
#include "simulation/solver/nonlinearSystem.h"
#include "simulation/solver/mixedSystem.h"
#include "simulation/solver/spatialDistribution.h"
#include "simulation/solver/synchronous.h"

#if defined(__cplusplus)
extern "C" {
#endif

#include <string.h>

#include "WaterTank_Control_functions.h"


extern void WaterTank_Control_callExternalObjectDestructors(DATA *_data, threadData_t *threadData);
#if !defined(OMC_NUM_NONLINEAR_SYSTEMS) || OMC_NUM_NONLINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_LINEAR_SYSTEMS) || OMC_NUM_LINEAR_SYSTEMS>0
#endif
#if !defined(OMC_NUM_MIXED_SYSTEMS) || OMC_NUM_MIXED_SYSTEMS>0
#endif
#if !defined(OMC_NO_STATESELECTION)
extern void WaterTank_Control_initializeStateSets(int nStateSets, STATE_SET_DATA* statesetData, DATA *data);
#endif
extern int WaterTank_Control_functionAlgebraics(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_function_storeDelayed(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_function_storeSpatialDistribution(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_function_initSpatialDistribution(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_updateBoundVariableAttributes(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_functionInitialEquations(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_functionInitialEquations_lambda0(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_functionRemovedInitialEquations(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_updateBoundParameters(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_checkForAsserts(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_function_ZeroCrossingsEquations(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_function_ZeroCrossings(DATA *data, threadData_t *threadData, double* gout);
extern int WaterTank_Control_function_updateRelations(DATA *data, threadData_t *threadData, int evalZeroCross);
extern const char* WaterTank_Control_zeroCrossingDescription(int i, int **out_EquationIndexes);
extern const char* WaterTank_Control_relationDescription(int i);
extern void WaterTank_Control_function_initSample(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_initialAnalyticJacobianG(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianA(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianB(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianC(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianD(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianF(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_initialAnalyticJacobianH(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);
extern int WaterTank_Control_functionJacG_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacA_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacB_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacC_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacD_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacF_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern int WaterTank_Control_functionJacH_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);
extern const char* WaterTank_Control_linear_model_frame(void);
extern const char* WaterTank_Control_linear_model_datarecovery_frame(void);
extern int WaterTank_Control_mayer(DATA* data, modelica_real** res, short *);
extern int WaterTank_Control_lagrange(DATA* data, modelica_real** res, short *, short *);
extern int WaterTank_Control_pickUpBoundsForInputsInOptimization(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);
extern int WaterTank_Control_setInputData(DATA *data, const modelica_boolean file);
extern int WaterTank_Control_getTimeGrid(DATA *data, modelica_integer * nsi, modelica_real**t);
extern void WaterTank_Control_function_initSynchronous(DATA * data, threadData_t *threadData);
extern void WaterTank_Control_function_updateSynchronous(DATA * data, threadData_t *threadData, long base_idx);
extern int WaterTank_Control_function_equationsSynchronous(DATA * data, threadData_t *threadData, long base_idx, long sub_idx);
extern void WaterTank_Control_read_simulation_info(SIMULATION_INFO* simulationData);
extern void WaterTank_Control_read_input_fmu(MODEL_DATA* modelData);
extern void WaterTank_Control_function_savePreSynchronous(DATA *data, threadData_t *threadData);
extern int WaterTank_Control_inputNames(DATA* data, char ** names);
extern int WaterTank_Control_dataReconciliationInputNames(DATA* data, char ** names);
extern int WaterTank_Control_dataReconciliationUnmeasuredVariables(DATA* data, char ** names);
extern int WaterTank_Control_initializeDAEmodeData(DATA *data, DAEMODE_DATA*);
extern int WaterTank_Control_functionLocalKnownVars(DATA* data, threadData_t* threadData);
extern int WaterTank_Control_symbolicInlineSystem(DATA* data, threadData_t* threadData);

#include "WaterTank_Control_literals.h"




#if defined(HPCOM) && !defined(_OPENMP)
  #error "HPCOM requires OpenMP or the results are wrong"
#endif
#if defined(_OPENMP)
  #include <omp.h>
#else
  /* dummy omp defines */
  #define omp_get_max_threads() 1
#endif

#if defined(__cplusplus)
}
#endif

#endif /* !defined(WaterTank_Control__MODEL_H) */


